<template>
  <div>
    <v-snackbar :color="currentNotificationColor" v-model="show">
      <v-progress-circular
        class="ma-2"
        indeterminate
        v-show="showProgress"
      ></v-progress-circular
      >{{ currentNotificationContent }}
      <v-btn text @click.native="close">Close</v-btn>
    </v-snackbar>
  </div>
</template>
<script lang="ts">
import Vue from "vue";
import { AppNotification } from "@/interfaces";
import { commitRemoveNotification } from "@/store/main/mutations";
import { readFirstNotification } from "@/store/main/getters";
import { dispatchRemoveNotification } from "@/store/main/actions";
export default Vue.extend({
  name: "NotificationsManager",
  data: () => ({
    show: false,
    text: "",
    showProgress: false,
    currentNotification: false as AppNotification | false,
  }),
  computed: {
    firstNotification: function () {
      return readFirstNotification(this.$store);
    },
    currentNotificationContent: function () {
      return (
        (this.currentNotification && this.currentNotification.content) || ""
      );
    },
    currentNotificationColor: function () {
      return (
        (this.currentNotification && this.currentNotification.color) || "info"
      );
    },
  },
  methods: {
    hide: function () {
      this.show = false;
    },
    removeCurrentNotification: function () {
      if (this.currentNotification) {
        commitRemoveNotification(this.$store, this.currentNotification);
      }
    },
    close: function () {
      this.hide();
      this.removeCurrentNotification();
    },
    setNotification: function (notification: AppNotification | false) {
      if (this.show) {
        this.hide();
      }
      if (notification) {
        this.currentNotification = notification;
        this.showProgress = notification.showProgress || false;
        this.show = true;
      } else {
        this.currentNotification = false;
      }
    },
  },
  watch: {
    firstNotification: function (newNotification: AppNotification | false) {
      if (newNotification !== this.currentNotification) {
        this.setNotification(newNotification);
        if (newNotification) {
          dispatchRemoveNotification(this.$store, {
            notification: newNotification,
            timeout: 5000,
          });
        }
      }
    },
  },
});
</script>
